{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//         ANOTHER FILE COPY TEST PROGRAM for GPC                       //}
{//                                                                      //}
{//         By Dr Abimbola A. Olowofoyeku (The African Chief);           //}
{//                                                                      //}
{//  This test program is released as part of the GNU Pascal project,    //}
{//  for the SOLE purpose of testing the routines in certain units.      //}
{//                                                                      //}
{//  This program is a free program; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk                      //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
PROGRAM BigCopy;

USES
GPCTYPES, SYSTEM, DOSH, DOS, GPCUTIL;
{$W-}
{$X+}

{ copy file Src to file Dest and return the number
  of bytes written - uses 4MB buffer!!! }
Function FCopy ( Const Src, Dest : String; BufSize : integer ) : Longint;
Var
 sH, dH : BinFile;
 count : Longint;
 rS, wS : integer;
 Buf   : PCopyBuf;
 T     : TFileTime;
 b     : boolean;

Begin
    FCopy := - 2;
    b := BinAssign ( sH, Src );
    b := BinAssign ( dH, Dest );

    If Not BinReset ( sH ) then exit;
    count := 0;
    FCopy := - 3;
    If Not BinReWrite ( dH )
    then begin
       b := BinClose ( sH );
       exit;
    end;
    rS := 1;
    wS := 1;

    GetFTime ( sH, T );

    Getmem ( Buf, BufSize );
    Count := 0;

    { loop and do the copying }
    While Not BinEof ( sH )
{    while (rS > 0) and (wS > 0 ) }
    do begin
       { read the source file }	
       BlockRead  ( sH, Buf^, BufSize, rS );
       If ( rS < 0 ) then begin  {Read Error}
    	  b := BinClose ( sH );
    	  b := BinClose ( dH );
    	  Freemem ( Buf, BufSize );
    	  FCopy := - 100; {Read error}
          Exit;
       end;

       { write to the destination file }
       BlockWrite ( dH, Buf^, rS, wS );
       If ( wS < rS ) then begin  {Error}
    	  b := BinClose ( sH );
    	  b := BinClose ( dH );
    	  Freemem ( Buf, BufSize );
    	  FCopy := - 200; {Write error}
          Exit;
       end;
       { increment the count by number of bytes written }
       Count := Count + wS;
    end;

    Freemem ( Buf, BufSize );
    FCopy := count; { return the number of bytes written }

    b := ( integer ( Count ) = integer ( sH.Size ) )
    and  ( integer ( sH.Size ) = integer ( dH.Size ) );

    If ( b = False ) then FCopy := - 1000; {file sizes don't match!}

    SetFTime ( dH, T );    { set the date/time stamp }
    b := BinClose ( sH );
    b := BinClose ( dH );
End; {* FCopy *}
{///////////////////////////////}

{ progress report function }
Function MyRep ( Reached,  Total : Longint ) : Longint;
begin
   Write ( '.' );
   MyRep := Reached;
end;{* MyRep *}


{* Main *}
Var
i  : Longint;
s1,
s2 : string;

Begin
   Writeln ( 'File Copy test program for GPC; 1997, Dr A Olowofoyeku' );
   If ( ParamCount < 2 )
   then begin
      Writeln ( 'Syntax = BIGCOPY <SourceFile> <DestFile>' );
      Halt;
   end;

   s1 := ParamStr ( 1 );
   s2 := ParamStr ( 2 );

   Write ( 'Copying ', s1, ' ... ' );
   i  := FCopy ( s1, s2, ( 256 * 1024 ) );  { 256kb buffer }
   Writeln;
   Writeln ( integer ( i ), ' bytes written to: ', s2 );
End.
