{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//                 DPMI.H IMPORT UNIT for GPC                           //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT DPMI;

INTERFACE

USES GPCTYPES;

{$W-}

Type __dpmi_raddr = record
            offset16 : Byte;
            segment : Byte;
          end {__dpmi_raddr};


Type __dpmi_paddr = record
            offset32 : Word;
            selector : Byte;
          end {__dpmi_paddr};


Type __dpmi_meminfo = record
            handle  : Word;
            size    : Word;
            address : Word;
          end {__dpmi_meminfo};


Type __dpmi_regs = record
         d : record
             edi : Word;
             esi : Word;
             ebp : Word;
             res : Word;
             ebx : Word;
             edx : Word;
             ecx : Word;
             eax : Word;
          end {d};

         x : record
            di, di_hi : Byte;
            si, si_hi : Byte;
            bp, bp_hi : Byte;
            res, res_hi : Byte;
            bx, bx_hi : Byte;
            dx, dx_hi : Byte;
            cx, cx_hi : Byte;
            ax, ax_hi : Byte;
            flags : Byte;
            es : Byte;
            ds : Byte;
            fs : Byte;
            gs : Byte;
            ip : Byte;
            cs : Byte;
            sp : Byte;
            ss : Byte;
          end {x};

        h : record
            edi : Array [0..3] of Byte;
            esi : Array [0..3] of Byte;
            ebp : Array [0..3] of Byte;
            res : Array [0..3] of Byte;
            bl, bh, ebx_b2, ebx_b3 : Byte;
            dl, dh, edx_b2, edx_b3 : Byte;
            cl, ch, ecx_b2, ecx_b3 : Byte;
            al, ah, eax_b2, eax_b3 : Byte;
          end {x};

   end {__dpmi_regs};

Type __dpmi_version_ret = record
            major : Byte;
            minor : Byte;
            flags : ShortInt;
            cpu   : Byte;
            master_pic : Byte;
            slave_pic  : Byte;
          end {__dpmi_version_ret};


Type __dpmi_free_mem_info = record
            largest_available_free_block_in_bytes : Word;
            maximum_unlocked_page_allocation_in_pages : Word;
            maximum_locked_page_allocation_in_pages : Word;
            linear_address_space_size_in_pages : Word;
            total_number_of_unlocked_pages : Word;
            total_number_of_free_pages : Word;
            total_number_of_physical_pages : Word;
            free_linear_address_space_in_pages : Word;
            size_of_paging_file_partition_in_pages : Word;
            reserved : Array [0..2] of Word;
          end {__dpmi_free_mem_info};


Type __dpmi_memory_info = record
            total_allocated_bytes_of_physical_memory_host : Word;
            total_allocated_bytes_of_virtual_memory_host : Word;
            total_available_bytes_of_virtual_memory_host : Word;
            total_allocated_bytes_of_virtual_memory_vcpu : Word;
            total_available_bytes_of_virtual_memory_vcpu : Word;
            total_allocated_bytes_of_virtual_memory_client : Word;
            total_available_bytes_of_virtual_memory_client : Word;
            total_locked_bytes_of_memory_client : Word;
            max_locked_bytes_of_memory_client : Word;
            highest_linear_address_available_to_client : Word;
            size_in_bytes_of_largest_free_memory_block : Word;
            size_of_minimum_allocation_unit_in_bytes : Word;
            size_of_allocation_alignment_unit_in_bytes : Word;
            reserved : Array [0..18] of Word;
          end {__dpmi_memory_info};


Type __dpmi_callback_info = record
             data16 : Array [0..1] of Word;
             code16 : Array [0..1] of Word;
             ip : Byte;
             reserved : Byte;
             data32 : Array [0..1] of Word;
             code32 : Array [0..1] of Word;
             eip : Word;
           end {__dpmi_callback_info};


Type __dpmi_shminfo = record
             size_requested : Word;
             size : Word;
             handle : Word;
             address : Word;
             name_offset : Word;
             name_selector : Byte;
             reserved1 : Byte;
             reserved2 : Word;
           end {__dpmi_shminfo};

{+// Unless otherwise noted, all functions return -1 on error, setting __dpmi_error to the DPMI error code */ }


procedure __dpmi_yield; C;
{= INT 0x2F AX=1680 }


function __dpmi_allocate_ldt_descriptors ( _count : Integer ) : Integer; C;
{= DPMI 0.9 AX=0000 }

function __dpmi_free_ldt_descriptor ( _descriptor : Integer ) : Integer; C;
{= DPMI 0.9 AX=0001 }

function __dpmi_segment_to_descriptor ( _segment : Integer ) : Integer; C;
{= DPMI 0.9 AX=0002 }

function __dpmi_get_selector_increment_value : Integer; C;
{= DPMI 0.9 AX=0003 }

function __dpmi_get_segment_base_address ( _selector : Integer;
                                         Var _addr : Word ) : Integer; C;
{= DPMI 0.9 AX=0006 }

function __dpmi_set_segment_base_address ( _selector : Integer; 
                                         _address : Word ) : Integer; C;
{= DPMI 0.9 AX=0007 }

function __dpmi_get_segment_limit ( _selector : Integer ) : Word; C;
{= LSL instruction }

function __dpmi_set_segment_limit ( _selector : Integer; 
                                  _limit : Word ) : Integer; C;
{= DPMI 0.9 AX=0008 }

function __dpmi_get_descriptor_access_rights ( _selector : Integer ) : Integer; C;
{= LAR instruction }

function __dpmi_set_descriptor_access_rights ( _selector : Integer; 
                                             _rights : Integer ) : Integer; C;
{= DPMI 0.9 AX=0009 }

function __dpmi_create_alias_descriptor ( _selector : Integer ) : Integer; C;
{= DPMI 0.9 AX=000a }

function __dpmi_get_descriptor ( _selector : Integer; 
                               Var _buffer ) : Integer; C;
{= DPMI 0.9 AX=000b }

function __dpmi_set_descriptor ( _selector : Integer;
                               Var _buffer ) : Integer; C;
{= DPMI 0.9 AX=000c }

function __dpmi_allocate_specific_ldt_descriptor ( _selector : Integer ) : Integer; C;
{= DPMI 0.9 AX=000d }


function __dpmi_get_multiple_descriptors ( _count : Integer; 
                                         Var _buffer ) : Integer; C;
{= DPMI 1.0 AX=000e }

function __dpmi_set_multiple_descriptors ( _count : Integer;
                                         Var _buffer ) : Integer; C;
{= DPMI 1.0 AX=000f }


function __dpmi_allocate_dos_memory ( _paragraphs : Integer; 
                                    Var _ret_selector_or_max : Integer ) : Integer; C;
{= DPMI 0.9 AX=0100 }

function __dpmi_free_dos_memory ( _selector : Integer ) : Integer; C;
{= DPMI 0.9 AX=0101 }

function __dpmi_resize_dos_memory ( _selector : Integer; 
                                  _newpara : Integer; 
                                  Var _ret_max : Integer ) : Integer; C;
{= DPMI 0.9 AX=0102 }


function __dpmi_get_real_mode_interrupt_vector ( _vector : Integer; 
                                               Var _address : __DPMI_RADDR ) : Integer; C;
{= DPMI 0.9 AX=0200 }

function __dpmi_set_real_mode_interrupt_vector ( _vector : Integer; 
                                               Var _address : __DPMI_RADDR ) : Integer; C;
{= DPMI 0.9 AX=0201 }

function __dpmi_get_processor_exception_handler_vector ( _vector : Integer; 
                                                       Var _address : __DPMI_PADDR ) : Integer; C;
{= DPMI 0.9 AX=0202 }

function __dpmi_set_processor_exception_handler_vector ( _vector : Integer; 
                                                       Var _address : __DPMI_PADDR ) : Integer; C;
{= DPMI 0.9 AX=0203 }

function __dpmi_get_protected_mode_interrupt_vector ( _vector : Integer; 
                                                    Var _address : __DPMI_PADDR ) : Integer; C;
{= DPMI 0.9 AX=0204 }

function __dpmi_set_protected_mode_interrupt_vector ( _vector : Integer; 
                                                    Var _address : __DPMI_PADDR ) : Integer; C;
{= DPMI 0.9 AX=0205 }


function __dpmi_get_extended_exception_handler_vector_pm ( _vector : Integer; 
                                                         Var _address : __DPMI_PADDR ) : Integer; C;
{= DPMI 1.0 AX=0210 }

function __dpmi_get_extended_exception_handler_vector_rm ( _vector : Integer; 
                                                         Var _address : __DPMI_PADDR ) : Integer; C;
{= DPMI 1.0 AX=0211 }

function __dpmi_set_extended_exception_handler_vector_pm ( _vector : Integer; 
                                                         Var _address : __DPMI_PADDR ) : Integer; C;
{= DPMI 1.0 AX=0212 }

function __dpmi_set_extended_exception_handler_vector_rm ( _vector : Integer; 
                                                         Var _address : __DPMI_PADDR ) : Integer; C;
{= DPMI 1.0 AX=0213 }


function __dpmi_simulate_real_mode_interrupt ( _vector : Integer; 
                                             Var _regs : __DPMI_REGS ) : Integer; C;
{= DPMI 0.9 AX=0300 }

function __dpmi_int ( _vector : Integer; 
                    Var _regs : __DPMI_REGS ) : Integer; C;
{=extern short __dpmi_int_ss, __dpmi_int_sp, __dpmi_int_flags; /* default to zero }

function __dpmi_simulate_real_mode_procedure_retf ( Var _regs : __DPMI_REGS ) : Integer; C;
{= DPMI 0.9 AX=0301 }

function __dpmi_simulate_real_mode_procedure_retf_stack ( Var _regs : __DPMI_REGS;
                                                        stack_bytes_to_copy : Integer; 
                                                        Const stack_bytes ) : Integer; C;
{= DPMI 0.9 AX=0301 }

function __dpmi_simulate_real_mode_procedure_iret ( Var _regs : __DPMI_REGS ) : Integer; C;
{= DPMI 0.9 AX=0302 }

(*
function __dpmi_allocate_real_mode_callback(_handler)(void): PVOID (;
                                            Var _regs: __DPMI_REGS;
                                            Var _ret: __DPMI_RADDR): Integer; C;
{= DPMI 0.9 AX=0303 }
*)

function __dpmi_free_real_mode_callback ( Var _addr : __DPMI_RADDR ) : Integer; C;
{= DPMI 0.9 AX=0304 }

function __dpmi_get_state_save_restore_addr ( Var _rm : __DPMI_RADDR;
                                            Var _pm : __DPMI_PADDR ) : Integer; C;
{= DPMI 0.9 AX=0305 }

function __dpmi_get_raw_mode_switch_addr ( Var _rm : __DPMI_RADDR;
                                         Var _pm : __DPMI_PADDR ) : Integer; C;
{= DPMI 0.9 AX=0306 }


function __dpmi_get_version ( Var _ret : __DPMI_VERSION_RET ) : Integer; C;
{= DPMI 0.9 AX=0400 }


function __dpmi_get_capabilities ( Var _flags : Integer;
                                 vendor_info : PChar ) : Integer; C;
{= DPMI 1.0 AX=0401 }


function __dpmi_get_free_memory_information ( Var _info : __DPMI_FREE_MEM_INFO ) : Integer; C;
{= DPMI 0.9 AX=0500 }

function __dpmi_allocate_memory ( Var _info : __DPMI_MEMINFO ) : Integer; C;
{= DPMI 0.9 AX=0501 }

function __dpmi_free_memory ( _handle : Word ) : Integer; C;
{= DPMI 0.9 AX=0502 }

function __dpmi_resize_memory ( Var _info : __DPMI_MEMINFO ) : Integer; C;
{= DPMI 0.9 AX=0503 }


function __dpmi_allocate_linear_memory ( Var _info : __DPMI_MEMINFO;
                                       _commit : Integer ) : Integer; C;
{= DPMI 1.0 AX=0504 }

function __dpmi_resize_linear_memory ( Var _info : __DPMI_MEMINFO;
                                     _commit : Integer ) : Integer; C;
{= DPMI 1.0 AX=0505 }

function __dpmi_get_page_attributes ( Var _info : __DPMI_MEMINFO;
                                    Var _buffer : ShortInt ) : Integer; C;
{= DPMI 1.0 AX=0506 }

function __dpmi_set_page_attributes ( Var _info : __DPMI_MEMINFO;
                                    Var _buffer : ShortInt ) : Integer; C;
{= DPMI 1.0 AX=0507 }

function __dpmi_map_device_in_memory_block ( Var _info : __DPMI_MEMINFO;
                                           _physaddr : Word ) : Integer; C;
{= DPMI 1.0 AX=0508 }

function __dpmi_map_conventional_memory_in_memory_block ( Var _info : __DPMI_MEMINFO;
                                                        _physaddr : Word ) : Integer; C;
{= DPMI 1.0 AX=0509 }

function __dpmi_get_memory_block_size_and_base ( Var _info : __DPMI_MEMINFO ) : Integer; C;
{= DPMI 1.0 AX=050a }

function __dpmi_get_memory_information ( Var _buffer : __DPMI_MEMORY_INFO ) : Integer; C;
{= DPMI 1.0 AX=050b }


function __dpmi_lock_linear_region ( Var _info : __DPMI_MEMINFO ) : Integer; C;
{= DPMI 0.9 AX=0600 }

function __dpmi_unlock_linear_region ( Var _info : __DPMI_MEMINFO ) : Integer; C;
{= DPMI 0.9 AX=0601 }

function __dpmi_mark_real_mode_region_as_pageable ( Var _info : __DPMI_MEMINFO ) : Integer; C;
{= DPMI 0.9 AX=0602 }

function __dpmi_relock_real_mode_region ( Var _info : __DPMI_MEMINFO ) : Integer; C;
{= DPMI 0.9 AX=0603 }

function __dpmi_get_page_size ( Var _size : Word ) : Integer; C;
{= DPMI 0.9 AX=0604 }


function __dpmi_mark_page_as_demand_paging_candidate ( Var _info : __DPMI_MEMINFO ) : Integer; C;
{= DPMI 0.9 AX=0702 }

function __dpmi_discard_page_contents ( Var _info : __DPMI_MEMINFO ) : Integer; C;
{= DPMI 0.9 AX=0703 }


function __dpmi_physical_address_mapping ( Var _info : __DPMI_MEMINFO ) : Integer; C;
{= DPMI 0.9 AX=0800 }

function __dpmi_free_physical_address_mapping ( Var _info : __DPMI_MEMINFO ) : Integer; C;
{= DPMI 0.9 AX=0801 }

{+// These next four functions return the old state */ }

function __dpmi_get_and_disable_virtual_interrupt_state : Integer; C;
{= DPMI 0.9 AX=0900 }

function __dpmi_get_and_enable_virtual_interrupt_state : Integer; C;
{= DPMI 0.9 AX=0901 }

function __dpmi_get_and_set_virtual_interrupt_state ( _old_state : Integer ) : Integer; C;
{= DPMI 0.9 AH=09 }

function __dpmi_get_virtual_interrupt_state : Integer; C;
{= DPMI 0.9 AX=0902 }


function __dpmi_get_vendor_specific_api_entry_point ( _id : PChar; 
                                                    Var _api : __DPMI_PADDR ) : Integer; C;
{= DPMI 0.9 AX=0a00 }


function __dpmi_set_debug_watchpoint ( Var _info : __DPMI_MEMINFO;
                                     _type : Integer ) : Integer; C;
{= DPMI 0.9 AX=0b00 }

function __dpmi_clear_debug_watchpoint ( _handle : Word ) : Integer; C;
{= DPMI 0.9 AX=0b01 }

function __dpmi_get_state_of_debug_watchpoint ( _handle : Word;
                                              Var _status : Integer ) : Integer; C;
{= DPMI 0.9 AX=0b02 }

function __dpmi_reset_debug_watchpoint ( _handle : Word ) : Integer; C;
{= DPMI 0.9 AX=0b03 }


function __dpmi_install_resident_service_provider_callback ( Var _info : __DPMI_CALLBACK_INFO ) : Integer; C;
{= DPMI 1.0 AX=0c00 }

function __dpmi_terminate_and_stay_resident ( return_code : Integer;
                                            paragraphs_to_keep : Integer ) : Integer; C;
{= DPMI 1.0 AX=0c01 }


function __dpmi_allocate_shared_memory ( Var _info : __DPMI_SHMINFO ) : Integer; C;
{= DPMI 1.0 AX=0d00 }

function __dpmi_free_shared_memory ( _handle : Word ) : Integer; C;
{= DPMI 1.0 AX=0d01 }

function __dpmi_serialize_on_shared_memory ( _handle : Word;
                                           _flags : Integer ) : Integer; C;
{= DPMI 1.0 AX=0d02 }

function __dpmi_free_serialization_on_shared_memory ( _handle : Word;
                                                    _flags : Integer ) : Integer; C;
{= DPMI 1.0 AX=0d03 }


function __dpmi_get_coprocessor_status : Integer; C;
{= DPMI 1.0 AX=0e00 }

function __dpmi_set_coprocessor_emulation ( _flags : Integer ) : Integer; C;
{= DPMI 1.0 AX=0e01 }

{+// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */ }
{+// Backwards compatibility stuff */ }

Type _go32_dpmi_registers = __dpmi_regs;


Type _go32_dpmi_meminfo = record
             available_memory : Word;
             available_pages : Word;
             available_lockable_pages : Word;
             linear_space : Word;
             unlocked_pages : Word;
             available_physical_pages : Word;
             total_physical_pages : Word;
             free_linear_space : Word;
             max_pages_in_paging_file : Word;
             reserved : Array [0..2] of Word;
           end {_go32_dpmi_meminfo};


function _go32_dpmi_simulate_int ( _vector : Integer; Var _regs : __DPMI_REGS ) : Integer;
AsmName '__dpmi_simulate_real_mode_interrupt';

function _go32_dpmi_simulate_fcall ( Var _regs : __DPMI_REGS ) : Integer;
AsmName '__dpmi_simulate_real_mode_procedure_retf';

function _go32_dpmi_simulate_fcall_iret ( Var _regs : __DPMI_REGS ) : Integer;
AsmName '__dpmi_simulate_real_mode_procedure_iret';

{
Const _go32_dpmi_get_free_memory_information(x) = __dpmi_get_free_memory_information((__dpmi_free_mem_info * )(x));
}

Type _go32_dpmi_seginfo = record
             size : Word;
             pm_offset : Word;
             pm_selector : Byte;
             rm_offset : Byte;
             rm_segment : Byte;
           end {_go32_dpmi_seginfo};

{+// returns zero if success, else dpmi error and info->size is max size */ }

function _go32_dpmi_allocate_dos_memory ( Var info : _GO32_DPMI_SEGINFO ) : Integer; C;
{+// set size to bytes/16, call, use rm_segment. Do not }
{-change anthing but size until the memory is freed. }
{=If error, max size is returned in size as bytes/16. }

function _go32_dpmi_free_dos_memory ( Var info : _GO32_DPMI_SEGINFO ) : Integer; C;
{+// set new size to bytes/16, call. If error, max size }
{=is returned in size as bytes/16 }

function _go32_dpmi_resize_dos_memory ( Var info : _GO32_DPMI_SEGINFO ) : Integer; C;
{+// uses pm_selector to free memory */ }

{+// These both use the rm_segment:rm_offset fields only */ }

function _go32_dpmi_get_real_mode_interrupt_vector ( vector : Integer; 
                                                   Var info : _GO32_DPMI_SEGINFO ) : Integer; C;

function _go32_dpmi_set_real_mode_interrupt_vector ( vector : Integer; 
                                                   Var info : _GO32_DPMI_SEGINFO ) : Integer; C;

{+// These do NOT wrap the function in pm_offset in an iret handler. }
{-You must provide an assembler interface yourself, or alloc one below. }
{=You may NOT longjmp out of an interrupt handler. }

function _go32_dpmi_get_protected_mode_interrupt_vector ( vector : Integer; 
                                                        Var info : _GO32_DPMI_SEGINFO ) : Integer; C;
{+// puts vector in pm_selector:pm_offset. */ }

function _go32_dpmi_set_protected_mode_interrupt_vector ( vector : Integer; 
                                                        Var info : _GO32_DPMI_SEGINFO ) : Integer; C;
{+// sets vector from pm_offset and pm_selector */ }

{+//********* HELPER FUNCTIONS **********/ }


function _go32_dpmi_chain_protected_mode_interrupt_vector ( vector : Integer; 
                                                          Var info : _GO32_DPMI_SEGINFO ) : Integer; C;
{+// sets up wrapper that calls function in pm_offset, chaining to old }
{=handler when it returns }

{+// These generate assember IRET-style wrappers for functions and set up stack */ }

function _go32_dpmi_allocate_iret_wrapper ( Var info : _GO32_DPMI_SEGINFO ) : Integer; C;
{+// Put function ptr in pm_offset, call, returns wrapper entry in pm_offset. */ }

function _go32_dpmi_free_iret_wrapper ( Var info : _GO32_DPMI_SEGINFO ) : Integer; C;
{+// assumes pm_offset points to wrapper, frees it */ }

{+// RMCB functions, automatically restructure the real-mode stack for the }
{-proper return type and set up correct PM stack. The callback }
{=(info->pm_offset) is called as ( *pmcb)(_go32_dpmi_registers *regs); }

function _go32_dpmi_allocate_real_mode_callback_retf ( Var info : _GO32_DPMI_SEGINFO;
                                                     Var regs : _GO32_DPMI_REGISTERS ) : Integer; C;
{+// points callback at pm_offset, returns seg:ofs of callback addr }
{-in rm_segment:rm_offset. Do not change any fields until freed. }
{=Interface is added to simulate far return }

function _go32_dpmi_allocate_real_mode_callback_iret ( Var info : _GO32_DPMI_SEGINFO;
                                                     Var regs : _GO32_DPMI_REGISTERS ) : Integer; C;
{+// same, but simulates iret */ }

function _go32_dpmi_free_real_mode_callback ( Var info : _GO32_DPMI_SEGINFO ) : Integer; C;
{+// frees callback */ }

{+// The following two variables may be used to change the default stack size }
{-for interrupts and rmcb wrappers to a user defined size from the default }
{=of 32Kbytes. Each RMCB and chain/iret wrapper gets it's own stack. }


{+// Convenience functions, the return value is *bytes* */ }

function _go32_dpmi_remaining_physical_memory : Word; C;

function _go32_dpmi_remaining_virtual_memory : Word; C;

{+// locks memory from a specified offset within the code/data selector */ }

function _go32_dpmi_lock_code ( Var _lockaddr;
                              _locksize : Word ) : Integer; C;

function _go32_dpmi_lock_data ( Var _lockaddr;
                              _locksize : Word ) : Integer; C;


function __djgpp_set_page_attributes ( Var our_addr;
                                     num_bytes : Word;
                                     attributes : Byte ) : Integer; C;

function __djgpp_map_physical_memory ( Var our_addr;
                                     num_bytes : Word;
                                     phys_addr : Word ) : Integer; C;

IMPLEMENTATION


END.
