{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//                FCNTL.H IMPORT UNIT for GPC                           //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}

UNIT FCNTL;

INTERFACE

USES GPCTYPES;
{$W-}

Const FD_CLOEXEC = $0001;

Const F_DUPFD = 1;
Const F_GETFD = 2;
Const F_GETFL = 3;
Const F_GETLK = 4;
Const F_SETFD = 5;
Const F_SETFL = 6;
Const F_SETLK = 7;
Const F_SETLKW = 8;

Const F_UNLCK = 0;
Const F_RDLCK = 1;
Const F_WRLCK = 2;

Const O_RDONLY  = $0000;
Const O_WRONLY  = $0001;
Const O_RDWR    = $0002;
Const O_ACCMODE = $0003;

Const O_BINARY    = $0004; {/* must fit in char, reserved by dos */}
Const O_TEXT      = $0008; {/* must fit in char, reserved by dos */}
Const O_NOINHERIT = $0080; {/* DOS-specific */}

Const O_CREAT = $0100; {/* second byte, away from DOS bits */}
Const O_EXCL = $0200;
Const O_NOCTTY = $0400;
Const O_TRUNC = $0800;
Const O_APPEND = $1000;
Const O_NONBLOCK = $2000;

Type flock = record
               l_len : OFF_T;
               l_pid : PID_T;
               l_start : OFF_T;
               l_type : ShortInt;
               l_whence : ShortInt;
             end {flock};

{= O_TEXT or O_BINARY }


function open ( _path : PChar;
              _oflag : Integer{;
              _3: ...} ) : Integer; C;

function creat ( _path : PChar;
               _mode : MODE_T ) : Integer; C;

function fcntl ( _fildes : Integer;
               _cmd : Integer{;
               _3: ...} ) : Integer; C;

Const SH_COMPAT = $0000;
Const SH_DENYRW = $0010;
Const SH_DENYWR = $0020;
Const SH_DENYRD = $0030;
Const SH_DENYNO = $0040;

Const _SH_COMPAT = SH_COMPAT;
Const _SH_DENYRW = SH_DENYRW;
Const _SH_DENYWR = SH_DENYWR;
Const _SH_DENYRD = SH_DENYRD;
Const _SH_DENYNO = SH_DENYNO;
{
Const S_IREAD = S_IRUSR;
Const S_IWRITE = S_IWUSR;
Const S_IEXEC = S_IXUSR;
}
{+// }
{-* For compatibility with other DOS C compilers. }
{= }

Const _O_RDONLY = O_RDONLY;
Const _O_WRONLY = O_WRONLY;
Const _O_RDWR = O_RDWR;
Const _O_APPEND = O_APPEND;
Const _O_CREAT = O_CREAT;
Const _O_TRUNC = O_TRUNC;
{Const _O_EXCL = O_EXC;}
Const _O_TEXT = O_TEXT;
Const _O_BINARY = O_BINARY;
Const _O_NOINHERIT = O_NOINHERIT;

{+// }
{-* Support for advanced filesystems (Windows 9x VFAT, NTFS, LFN etc.) }
{= }

Const _FILESYS_UNKNOWN = $80000000;
Const _FILESYS_CASE_SENSITIVE = $0001;
Const _FILESYS_CASE_PRESERVED = $0002;
Const _FILESYS_UNICODE = $0004;
Const _FILESYS_LFN_SUPPORTED = $4000;
Const _FILESYS_VOL_COMPRESSED = $8000;


function _get_volume_info ( _path : PChar;
                          Var _max_file_len : Integer;
                          Var _max_path_len : Integer;
                          _filesystype : PChar ) : Word; C;

function _use_lfn ( _path : PChar ) : Char; C;

function _lfn_gen_short_fname ( _long_fname : PChar;
                              _short_fname : PChar ) : PChar; C;

Const _LFN_CTIME = 1;
Const _LFN_ATIME = 2;


function _lfn_get_ftime ( _handle : Integer;
                        _which : Integer ) : Word; C;


function _preserve_fncase : Char; C;

IMPLEMENTATION

end.
