{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//         TEST PROGRAM for GPC - TESTS THE FILE COPY ROUTINES          //}
{//                                                                      //}
{//         By Dr Abimbola A. Olowofoyeku (The African Chief);           //}
{//                                                                      //}
{//  This test program is released as part of the GNU Pascal project,    //}
{//  for the SOLE purpose of testing the routines in certain units.      //}
{//                                                                      //}
{//  This program is a free program; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk                      //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
PROGRAM FILECOPY;

USES SYSTEM, GPCUTIL;

{$W-}
{$X+}

{ progress report "callback" function }
Function MyRep ( Reached,  Total : Longint ) : Longint;
begin
   Write ( '.' );
   MyRep := Reached;
end; {* MyRep *}

{ * Main * }
Var
i : Longint;
s1, s2 : string [255];
s3 : string [30];
Size, j : integer;

Begin
   Writeln ( 'File Copy test program for GPC; 1997, Dr A Olowofoyeku' );
   If ParamCount < 2
   then begin
      Writeln ( 'Syntax = FILECOPY <SourceFile> <DestFile> [BufferSize]' );
      Halt ( 1 );
   end;

   Size := ( 256 * 1024 );       { 256kb buffer! }
   s1 := ParamStr ( 1 ); { source file }
   s2 := ParamStr ( 2 ); { target file }
   s3 := ParamStr ( 3 ); { optional buffer size }

   If s3 <> '' then begin
     Val ( s3, Size, j );
     if j <> 0 then Size := ( 256 * 1024 );
   end;

   i := CopyFileEx ( s1, s2, Size, MyRep ) ;
   {i := CopyFile ( s1, s2 , Size ) ;}

   Writeln;
   Writeln ( integer ( i ),
   ' bytes written to: ', s2, ' ( BufferSize = ', ( Size Div 1024 ), 'K)' );
End.

