{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//               BORLAND COMPATIBLE "STRINGS" UNIT for GPC              //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT Strings;

INTERFACE

USES GPCTYPES;

{$X+}    { use extended syntax }

Function StrCopy  ( Dest, Src : PChar ) : pChar;
AsmName 'strcpy';

Function StrLCopy ( Dest, Source : pChar; Count : Integer ) : pChar;
AsmName 'strncpy';

Function StrComp  ( s1, s2 : pChar ) : integer;
AsmName 'strcmp';

Function StrIComp ( Str1, Str2 : PChar ) : Integer;
AsmName 'stricmp';

Function StrLComp ( s1, s2 : pChar; Count : integer ) : integer;
AsmName 'strncmp';

Function StrLCat  ( Dest, Source : pChar; Count : Integer ) : pChar;
AsmName 'strncat';

Function StrLIComp ( Str1, Str2 : PChar; Count : integer ) : Integer;
AsmName 'strnicmp';

{ converts C string to upper case }
Function StrUpper ( p : pChar ) : pChar;
AsmName 'strupr';

{ converts C string to lower case }
Function StrLower ( p : pChar ) : pChar;
AsmName 'strlwr';

Function  StrScan  ( Str : PChar;Ch : Char ) : pChar;
AsmName 'strchr';

Function  StrNew  ( Str : PChar ) : PChar;
AsmName 'strdup';

Function  StrPos  ( Str, SubStr : pChar ) : pChar;
AsmName 'strstr';

Function  StrRScan ( Str : PChar;Ch : Char ) : pChar;
AsmName 'strrchr';

Function StrLen  ( Src : pChar ) : integer; C;

Function StrCat  ( Dest, Src : pChar ) : pChar; C;

{ ///////// my own functions ///////// }
{ Convert a "C" string to a "Pascal" string }
Function StrPas   ( Src : pChar ) : String;

{ Convert a "Pascal" string to a "C" string }
function StrPCopy ( Dest : pChar; Src : String ) : pChar;

{/ adds Pascal String (source) to the end of dest /}
Function StrPCat  ( Dest : PChar; Source : String ) : pChar;

{/ adds Character (source) to the end of dest /}
Function StrPCatCh ( Dest : PChar; Source : Char ) : pChar;

{ move count chars from source to dest}
Function  StrMove  ( Dest, Source : pChar; Count : Integer ) : pChar;

{ return a pointer to next string }
Function  StrNext  ( Str : pChar ) : pChar;

{ return a pointer to previous string }
Function  StrPrev  ( Str : pChar ) : pChar;

{ return a pointer to the end of the string }
Function  StrEnd  ( Str : pChar ) : pChar;

{ allocate a Pascal string on the heap and return pointer to it }
Function  StrPNew ( Str : String ) : PChar;

{ dispose a string from the heap }
Procedure StrDispose ( Str : PChar );
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
IMPLEMENTATION
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
function StrPas ( Src : pChar ) : String;
var
S : String;
begin
   S := '';
   if ( Src <> NIL )
   then while ( ( Src^ <> chr ( 0 ) ) AND ( length ( S ) < S.capacity ) )
   do begin
      S := S + Src^;
      inc ( Src );
   end;
   StrPas := S;
end; {* StrPas *}
{///////////////////////////////}
function StrPCopy ( Dest : pChar; Src : String ) : pChar;
var
i, j : integer;
p : pChar;
begin
   j := length ( Src );
   p := Dest;
   for i := 1 to j
   do begin
     p^ := Src [i];
     Inc ( p );
   end;
   p^ := Chr ( 0 );
   StrpCopy := Dest;
end; {* StrpCopy *}
{///////////////////////////////}
Function StrPCat ( Dest : PChar; Source : String ) : pChar;
Begin
   Source  := Source + Chr ( 0 );
   StrPCat := StrCat ( Dest, @Source [1] );
End; {* StrpCat *}
{///////////////////////////////}
Function StrPCatCh ( Dest : PChar; Source : Char ) : pChar;
Var
s : string [3];
Begin
   s := Source + Chr ( 0 );
   StrPCatCh := StrCat ( Dest, @s [1] );
end; {* StrpCatCh*}
{///////////////////////////////}
Function StrMove ( Dest, Source : pChar; Count : Integer ) : pChar;
Var
p : pChar;
Begin
  GetMem ( p, Succ ( Count ) );
  p := StrLCopy ( p, Source, Count );
  StrMove := StrCopy ( Dest, p );
  Freemem ( p, Succ ( Count ) );
End; {* StrMove *}
{/////////////////////////////}
Function StrNext ( Str : pChar ) : pChar;
Begin
   StrNext := Str + 1;
End; {* StrNext *}
{/////////////////////////////}
Function StrPrev ( Str : pChar ) : pChar;
Begin
   StrPrev := Str - 1;
End; {* StrPrev *}
{/////////////////////////////}
Function StrEnd ( Str : pChar ) : pChar;
Begin
  StrEnd := Str + StrLen ( Str );
End; {* StrEnd *}
{/////////////////////////////}
Function StrPNew ( Str : String ) : PChar;
Begin
 StrPNew := Nil;
 If ( Str <> '' )
 then begin
    Str := Str + chr ( 0 );
    StrPNew := StrNew ( @Str [1] );
 end;
End; {* StrpNew *}
{/////////////////////////////}
Procedure StrDispose ( Str : PChar );
Begin
  If ( Str <> Nil ) and ( Str^ <> Chr ( 0 ) )
  then begin
    FreeMem ( Str, Succ ( StrLen ( Str ) ) );
    Str := Nil;
  end;
End; {* StrDispose *}
{/////////////////////////////}
{/////////////////////////////}
{/////////////////////////////}
{/////////////////////////////}
{/////////////////////////////}
End.
