{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//               "DELPHI" Compatible SYSUTILS UNIT FOR GPC              //}
{//                     !!! INCOMPLETE !!!!                              //}
{//   !!! some things are missing, and some are in other units !!!       //}
{//            (e.g., the DOS, and STRINGS units)                        //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  !!! Some of the functions in this unit are not portable !!!         //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT SYSUTILS;

INTERFACE

USES
GPCTYPES, SYSTEM, DOSH, GPCUTIL;

{$W-}
{$X+}

{ file attribute constants }
Const
faNormal      = $00;
faReadOnly    = $01;
faHidden      = $02;
faSysFile     = $04;
faVolumeID    = $08;
faDirectory   = $10;
faArchive     = $20;
faAnyFile     = $3F;


{ file access modes }
Const
fmOpenRead       = $0000;
fmOpenWrite      = $0001;
fmOpenReadWrite  = $0002;
fmShareCompat    = $0000;
fmShareExclusive = $0010;
fmShareDenyWrite = $0020;
fmShareDenyRead  = $0030;
fmShareDenyNone  = $0040;


{  set an exit procedure }
{  !!! any program that uses this must call "HALT" to }
{  terminate - otherwise, GPF !!!! }
{  !!! set exit procedures only in units !!! }
Function  AddExitProc ( Procedure aProc ) : Integer; AsmName 'atexit';

{ convert a string to uppercase }
Function  UpperCase ( c : string ) : string;

{ convert a string to lowercase }
Function  LowerCase ( c : string ) : string;

{ return just the extension }
Function  ExtractFileExt ( Const s : string ) : string;
AsmName '_p_justextension';

{ change the extension
!!! here, unlike Delphi, you must not put the dot !!! }
Function  ChangeFileExt ( Const s, Ext : string ) : string;
AsmName '_p_forceextension';

{ return the full path name }
Function  ExpandFileName ( s : string ) : string;
AsmName '_p_fullpathname';

{ does a file exist ?}
Function  FileExists ( s : string ) : Boolean;
AsmName '_p_existfile';

{ return just the path name part }
Function  ExtractFilePath ( s : string ) : string;
AsmName '_p_justpathname';

{ return just the file name part }
Function  ExtractFileName ( s : string ) : string;
AsmName '_p_justfilename';

{ write to a file }
Function FileWrite  ( Handle : integer; Var Buf; Count : integer ) : integer;
AsmName 'write';

{ read from a file }
Function FileRead   ( Handle : integer; Var Buf; Count : integer ) : integer;
AsmName 'read';

{ open a file }
Function FileOpen   ( Fname : string; Mode : integer ) : integer;

{ create a file and return its handle }
Function FileCreate ( Fname : string ) : integer;

{ position the file pointer to "offset" }
Function FileSeek ( Handle : Integer; offset : OFF_T; origin : Integer )
: OFF_T; AsmName 'lseek';

{ close a file }
Function FileClose  ( Handle : integer ) : integer;
AsmName 'close';

{ rename a file }
Function  RenameFile ( OldName, NewName : string ) : Boolean;

{ delete a file }
Function  DeleteFile ( FileName : string ) : Boolean;

{ return the date of a file }
Function  FileAge ( FileName : String ) : integer;

{ return the date of a file }
Function  FileGetDate ( handle : integer ) : integer;

{ set the file attribute }
Function  FileSetAttr ( FileName : String; Attr : integer ) : integer;

{ get the file attribute }
Function  FileGetAttr ( FileName : String ) : integer;

{ !!! dummy function: not implemented !!!}
Procedure FileSetDate ( handle, aDate : integer );
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
IMPLEMENTATION
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
function _open ( path : PChar; oflag : Integer ) : Integer;C;
function remove ( _filename : PChar ) : Integer; C;
function rename ( _old : PChar;_new : PChar ) : Integer; C;
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
Function RenameFile ( OldName, NewName : string ) : Boolean;
Begin
   AddNull ( OldName );
   AddNull ( NewName );
   RenameFile := rename ( @OldName [1], @NewName [1] ) = 0;
End; {* RenameFile *}
{///////////////////////////////}
Function DeleteFile ( FileName : string ) : Boolean;
Begin
   AddNull ( FileName );
   DeleteFile := remove ( @FileName [1] ) = 0;
End; {* DeleteFile *}
{///////////////////////////////}
Function FileCreate ( Fname : string ) : integer;
Begin
   FileCreate := CreateFile ( Fname );
End;{* FileCreate *}
{///////////////////////////}
Function FileOpen   ( Fname : string; Mode : integer ) : integer;
Begin
   AddNull ( FName );
   FileOpen := _open ( @FName [1], Mode );
End;{* FileOpen *}
{///////////////////////////////}
Function UpperCase ( c : string ) : string;
Var
i : integer;
Begin
  for i := 1 to length ( c )
  do c [i] := UpCase ( c [i] );
  UpperCase := c;
End; {* uppercase *}
{/////////////////////////////}
Function LowerCase ( c : string ) : string;
Var
i : integer;
Begin
  for i := 1 to length ( c )
  do c [i] := LoCase ( c [i] );
  LowerCase := c;
End; {* lowercase *}
{/////////////////////////////}
Function  FileGetAttr ( FileName : String ) : integer;
Var
Attr : Word;
Begin
   AddNull ( FileName );
   _dos_getfileattr ( @FileName [1], Attr );
   FileGetAttr := Attr;
End;{* FileGetAttr *}
{///////////////////////////////}
Function  FileSetAttr ( FileName : String; Attr : integer ) : integer;
Begin
   AddNull ( FileName );
   FileSetAttr := _dos_setfileattr ( @FileName [1], Attr );
End;{* FileSetAttr *}
{///////////////////////////////}
Function  FileAge ( FileName : String ) : integer;
Var
i : integer;
Begin
   i := FileOpen ( FileName, fmOpenRead );
   if i >=0
   then begin
      FileAge := FileGetDate ( i );
      FileClose ( i );
   end
   else FileAge := SysError;
End;{* FileAge *}
{///////////////////////////////}
Function  FileGetDate ( handle : integer ) : integer;
Var
i : integer;
f : FileSTAT;
Begin
   i := fstat ( handle, f );
   if i = 0
   then FileGetDate := f.st_atime
   else FileGetDate := SysError;
End;{* FileGetDate *}
{///////////////////////////////}
Procedure FileSetDate ( handle, aDate : integer );
Begin
End;{* FileSetDate *}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
{///////////////////////////////}
END.



