{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//         TEST PROGRAM for GPC  - TESTS THE DPMI UNIT                  //}
{//                                                                      //}
{//         By Dr Abimbola A. Olowofoyeku (The African Chief);           //}
{//                                                                      //}
{//  This test program is released as part of the GNU Pascal project,    //}
{//  for the SOLE purpose of testing the routines in certain units.      //}
{//                                                                      //}
{//  This program is a free program; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk                      //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
PROGRAM DPMITEST;

USES DPMI;

{$X+}
{$W-}

Var
version     : __Dpmi_Version_Ret;
FreeMemInfo : __Dpmi_Free_Mem_Info;
MapInfo     : __DPMI_MEMINFO;
PageSize    : word;

Function Page2Byte ( Page: Word ) : Word;
Begin
   Page2Byte := ( Page * PageSize );
End; {* Page2Byte *}

Function Page2KB ( Page: Word ) : Word;
Begin
    Page2KB := ( Page2Byte ( Page ) Div ( 1024 ) );
End; {* Page2KB *}

Begin
    Writeln ( 'DPMI Information ' );
    Writeln ( '---------------- ' );

  __Dpmi_Get_Version ( version );
  With Version
  do begin
    writeln ( 'System CPU type     : ', cpu, '86' );
    writeln ( 'DPMI Version (major): ', major );
    writeln ( 'DPMI Version (minor): ', minor );
  end;

  { 1 dpmi page = 4096 bytes }
   { get the page size }
  __dpmi_get_page_size ( PageSize );
    Writeln ( 'DPMI Pages Size     : ', PageSize, ' bytes.' );

  __Dpmi_Get_Free_Memory_Information ( FreeMemInfo );
  With FreeMemInfo
  do begin

    writeln ( 'Largest Free block  : ',
    ( largest_available_free_block_in_bytes ) Div 1024, ' KB' );

    writeln ( 'Total Physical Mem  : ',
    Page2KB ( total_number_of_physical_pages ), ' KB' );

    writeln ( 'Total Free pages    : ',
    Page2KB ( total_number_of_free_pages ), ' KB' );

    writeln ( 'Total Unlocked pages: ',
    Page2KB ( total_number_of_unlocked_pages ), ' KB' );

    writeln ( 'Total Linear Space  : ',
    Page2KB ( linear_address_space_size_in_pages ), ' KB' );

    writeln ( 'Free Linear Space   : ',
    Page2KB ( free_linear_address_space_in_pages ), ' KB' );

    writeln ( 'Pages in Swap File  : ',
    Page2KB ( size_of_paging_file_partition_in_pages ), ' KB' );

  end;

End.
