{//////////////////////////////////////////////////////////////////////////}
{//                                                                      //}
{//                UNISTD.H IMPORT UNIT for GPC                          //}
{//                                                                      //}
{//  v1.00 - by Dr Abimbola A. Olowofoyeku (The African Chief);          //}
{//                                                                      //}
{//  This package is released as part of the GNU Pascal project.         //}
{//                                                                      //}
{//  NOTE - SOME OF THE ROUTINES IN THIS UNIT MAY NOT WORK CORRECTLY.    //}
{//  TEST CAREFULLY AND USE WITH CARE !!!                                //}
{//                                                                      //}
{//  This library is a free library; you can redistribute and/or modify  //}
{//  it under the terms of the GNU Library General Public License,       //}
{//  version 2, as published by the Free Software Foundation.            //}
{//                                                                      //}
{//  This library is distributed in the hope that it will be useful,     //}
{//  but WITHOUT ANY WARRANTY; without even the implied warranty of      //}
{//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the       //}
{//  GNU Library General Public License for more details.                //}
{//                                                                      //}
{//  You should have received a copy of the GNU Library General Public   //}
{//  License along with this library (see the file COPYING.LIB);         //}
{//  if not, write to the Free Software Foundation, Inc., 675 Mass Ave,  //}
{//  Cambridge, MA 02139, USA.                                           //}
{//                                                                      //}
{//  v1.00, May 1997 - Dr A Olowofoyeku: laa12@keele.ac.uk               //}
{//  Homepage: http://ourworld.compuserve.com/homepages/African_Chief    //}
{//////////////////////////////////////////////////////////////////////////}
UNIT UNISTD;

INTERFACE

USES GPCTYPES;
{$W-}

Const SEEK_SET = 0;
Const SEEK_CUR = 1;
Const SEEK_END = 2;

Const F_OK = $01;
Const R_OK = $02;
Const W_OK = $04;
Const X_OK = $08;

Const STDIN_FILENO  = 0;
Const STDOUT_FILENO = 1;
Const STDERR_FILENO = 2;

Const _PC_CHOWN_RESTRICTED = 1;
Const _PC_LINK_MAX         = 2;
Const _PC_MAX_CANON        = 3;
Const _PC_MAX_INPUT        = 4;
Const _PC_NAME_MAX         = 5;
Const _PC_NO_TRUNC         = 6;
Const _PC_PATH_MAX         = 7;
Const _PC_PIPE_BUF         = 8;
Const _PC_VDISABLE         = 9;

Const _POSIX_CHOWN_RESTRICTED = 0;
{ #undef _POSIX_JOB_CONTROL }
Const _POSIX_NO_TRUNC         = 0;
{ #undef _POSIX_SAVED_IDS }
Const _POSIX_VDISABLE         = - 1;
Const _POSIX_VERSION          = 199009;

Const _SC_ARG_MAX     = 1;
Const _SC_CHILD_MAX   = 2;
Const _SC_CLK_TCK     = 3;
Const _SC_JOB_CONTROL = 4;
Const _SC_NGROUPS_MAX = 5;
Const _SC_OPEN_MAX    = 6;
Const _SC_SAVED_IDS   = 7;
Const _SC_STREAM_MAX  = 8;
Const _SC_TZNAME_MAX  = 9;
Const _SC_VERSION     = 10;

Type
IntArr2 = Array [0..1] of Integer;

procedure __exit ( _STATUS : integer ); C;

procedure _exit ( _STATUS : integer ); C;

function access ( _path : PChar;
                _amode : Integer ) : Integer; C;

function alarm ( _seconds : Word ) : Word; C;

function chdir ( _path : PChar ) : Integer; C;

function chown ( _path : PChar;
               _owner : UID_T;
               _group : GID_T ) : Integer; C;

function close ( _fildes : Integer ) : Integer; C;

function ctermid ( _s : PChar ) : PChar; C;

function dup ( _fildes : Integer ) : Integer; C;

function dup2 ( _fildes : Integer;
              _fildes2 : Integer ) : Integer; C;

function execl ( _path : PChar;
               _arg : PChar;
               _3 : VarArgs ) : Integer; C;
{
function execle(_path: PChar;
                _arg: PChar;
                _3: VarArgs): Integer; C;
}
function execlp ( _file : PChar;
                _arg : PChar;
                _3 : VarArgs ) : Integer; C;

function execv ( _path : PChar;
               _argv : array of PChar ) : Integer; C;

function execve ( _path : PChar;
                _argv : array of PChar;
                _envp : array of PChar ) : Integer; C;

function execvp ( _file : PChar;
                 _argv : array of PChar ) : Integer; C;

function fork : PID_T; C;

function fpathconf ( _fildes : Integer;
                   _name : Integer ) : LongInt; C;

function getcwd ( _buf : PChar;
                _size : SIZE_T ) : PChar; C;

function getegid : GID_T; C;

function geteuid : UID_T; C;

function getgid : GID_T; C;

function getgroups ( _gidsetsize : Integer;
                   Var _grouplist : GID_T ) : Integer; C;

function getlogin : PChar; C;

function getopt ( _argc : Integer; 
                _argv : array of PChar;
                _optstring : PChar ) : Integer; C;

function getpgrp : PID_T; C;

function getpid : PID_T; C;

function getppid : PID_T; C;

function getuid : UID_T; C;

function isatty ( _fildes : Integer ) : Integer; C;

function link ( _existing : PChar;
              _new : PChar ) : Integer; C;

function lseek ( _fildes : Integer;
               _offset : OFF_T;
               _whence : Integer ) : OFF_T; C;

function pathconf ( _path : PChar;
                  _name : Integer ) : LongInt; C;

function pause : Integer; C;

function pipe ( _filde : IntArr2 ) : Integer; C;

function read ( _fildes : Integer;
              Var _buf;
              _nbyte : SIZE_T ) : SSIZE_T; C;

function rmdir ( _path : PChar ) : Integer; C;

function setgid ( _gid : GID_T ) : Integer; C;

function setpgid ( _pid : PID_T;
                 _pgid : PID_T ) : Integer; C;

function setsid : PID_T; C;

function setuid ( uid : UID_T ) : Integer; C;

function sleep ( _seconds : Word ) : Word; C;

function sysconf ( _name : Integer ) : LongInt; C;

function tcgetpgrp ( _fildes : Integer ) : PID_T; C;

function tcsetpgrp ( _fildes : Integer;
                   grp_id : PID_T ) : Integer; C;

function ttyname ( _fildes : Integer ) : PChar; C;

function unlink ( _path : PChar ) : Integer; C;

function write ( _fildes : Integer;
               Var _buf;
               _nbyte : SIZE_T ) : SSIZE_T; C;

{+// additional access() checks */ }
Const D_OK = $10;


function brk ( Var _heaptop ) : Integer; C;

function __file_exists ( _fn : PChar ) : Integer; C;

function fsync ( _fd : Integer ) : Integer; C;

function ftruncate ( _1 : Integer;
                   _2 : OFF_T ) : Integer; C;

function getdtablesize : Integer; C;

function gethostname ( buf : PChar;
                     size : Integer ) : Integer; C;

function getpagesize : Integer; C;

function getwd ( __buffer : PChar ) : PChar; C;

function nice ( _increment : Integer ) : Integer; C;

procedure sbrk ( _delta : Integer ); C;

function symlink ( a : PChar;
                 b : PChar ) : Integer; C;

function sync : Integer; C;

function truncate ( a : PChar;
                  _2 : OFF_T ) : Integer; C;

function usleep ( _useconds : Word ) : Word; C;

function vfork : PID_T; C;


IMPLEMENTATION


end.
